% Sub-Matlab program for :
% Gapen, Michael T. and Thomas F. Cosimano, 
% "Sovling Ramsey Problems with Nonlinear Projection Methods," 
% Studies in Nonlinear Dynamics and Econometrics, Vol. 9, Spring
% 2005.

function c=hpfilter(y,quart)
% function c=hpf(y,quart);  quart = 1600 for "quarterly data"
% HPF - HP Filter.
% Expects matrix y: T x nvar; returns T x nvar matrix of DETRENDED y
% Ellen R. McGrattan,  4-23-87
% Revised, 3-22-92, ERM
% Adapted to MATLAB 5, 24-6-97, Marco A. Maffezzoli

[t,k]=size(y);
i=[1,1,2,2,1:t-2,2:t-2,3:t-2,3:t-1,3:t,t-1,t-1,t,t]';
j=[1,2,1,2,3:t,3:t-1,3:t-2,2:t-2,1:t-2,t-1,t,t-1,t]';
s=[1+quart,-2*quart,-2*quart,1+5*quart,quart*ones(1,t-2),...
   -4*quart*ones(1,t-3),(1+6*quart)*ones(1,t-4),...
   -4*quart*ones(1,t-3),quart*ones(1,t-2),...
   1+5*quart,-2*quart,-2*quart,1+quart]';
m=sparse(i,j,s);
c=y-m\y;