% Sub-Matlab program for :
% Gapen, Michael T. and Thomas F. Cosimano, 
% "Sovling Ramsey Problems with Nonlinear Projection Methods," 
% Studies in Nonlinear Dynamics and Econometrics, Vol. 9, Spring
% 2005.
%
% function xmat=lambdapoly(ord,x)
%
% Purpose: Create bivariate Chebyshev Polynomial for money
%
% Source: Christian Haefke and Wouter den Haan, UCSD
%
% ========================================================

function xmat=lambdapoly(ord,x);

nthetaord=ord(1);
ngord=ord(2);

xtheta = chebpol(nthetaord,x(:,1));
xg     = chebpol(ngord,x(:,2));

for tj=0:nthetaord;
   for gj=0:ngord;
      xmat(:,tj*(ngord+1)+gj+1)=xtheta(:,tj+1).*xg(:,gj+1);
   end;
end;
