% Sub-Matlab program for :
% Gapen, Michael T. and Thomas F. Cosimano, 
% "Sovling Ramsey Problems with Nonlinear Projection Methods," 
% Studies in Nonlinear Dynamics and Econometrics, Vol. 9, Spring
% 2005.
%
% function xu = scalup(x,xmin,xmax);
%
% Purpose: Linearly rescales every element of the vector x from [-1,1] 
% to  [xmin,xmax] where x,xmin,xmax can be vectors as long as they are 
% all of the same dimension
%
% Source: Christian Haefke and Wouter den Haan, UCSD
%
% =====================================================================
function xu = scalup(x,xmin,xmax);

[r c]   = size(x);
a       = (xmin+xmax)'/2;
b       = (xmax-xmin)'/2;
xu      = a*ones(1,r) + ( b*ones(1,r) ).*x';
xu      = xu';

% =====================================================================